open util/boolean

abstract sig Student{
  id: one ID,
  major: one Major,
  university: lone University,
  isLegal: Bool,
  classmates: set Student,
}

sig Graduate extends Student{}
sig Undergraduate extends Student{}
sig ID{}
sig Major{}
sig University{}

fact unique_ids {
  all disj s, t: Student | s.id != t.id
}

fact no_id_without_student {
  all i: ID | one s: Student | s.id = i
}

fact legal_in_university {
  all s: Student | (s.university != none) iff (s.isLegal = True)
}

fact classmates_have_same_major_and_uni {
  all disj s, t: Student | (s.major = t.major and s.university = t.university) 
                                  iff (s in t.classmates)
}

fact no_self_classmate {
  all s: Student | s not in s.classmates
}

fact no_graduate_and_undergraduate_are_classmates {
  all s: Graduate, t: Undergraduate | (s not in t.classmates) and (t not in s.classmates)
}

pred show{}

run show for 2 University, 3 Major, 3 Student, 3 ID
