import org.junit.Test;

import static org.junit.Assert.assertEquals;

public class KnapsackTest {
    @Test
    public void testKnapsack() {
        int actual = Knapsack.solve(new int[]{0, 1, 2}, new int[]{0, 1, 2}, 10);
        int expected = 3;
        assertEquals(expected, actual);
    }

    @Test(expected = IllegalArgumentException.class)
    public void testValuesIsNull() {
        Knapsack.solve(new int[]{0}, null, 0);
    }

    @Test(expected = IllegalArgumentException.class)
    public void testWeightsIsNull() {
        Knapsack.solve(new int[]{0}, null, 0);
    }

    @Test(expected = IllegalArgumentException.class)
    public void testArraysHaveDifferentLengths() {
        Knapsack.solve(new int[]{0}, new int[]{0, 0}, 0);
    }

    @Test
    public void testKnapsackCoverage() {
        int actual = Knapsack.solve(new int[]{1, 2, 5}, new int[]{1, 2, 5}, 4);
        int expected = 3;
        assertEquals(expected, actual);
    }

    @Test
    public void testKnapsackFunctional() {
        // no items
        assertEquals(0, Knapsack.solve(new int[]{}, new int[]{}, 0));

        // one item
        assertEquals(0, Knapsack.solve(new int[]{0}, new int[]{0}, 0));
        assertEquals(2, Knapsack.solve(new int[]{2}, new int[]{0}, 1));
        assertEquals(0, Knapsack.solve(new int[]{0}, new int[]{2}, 1));
        assertEquals(1, Knapsack.solve(new int[]{1}, new int[]{1}, 1));

        // several items
        assertEquals(5, Knapsack.solve(new int[]{2, 1, 3}, new int[]{2, 1, 3}, 5));
        assertEquals(9, Knapsack.solve(new int[]{3, 6, 2}, new int[]{2, 2, 2}, 5));
    }
}